/**
 * 
 */
package com.goods;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.HashMap;

import org.geoserver.catalog.Catalog;
import org.geoserver.catalog.FeatureTypeInfo;
import org.geoserver.config.GeoServer;
import org.geoserver.config.ServiceInfo;
import org.geoserver.platform.ServiceException;
import org.geotools.data.DefaultQuery;
import org.geotools.data.FeatureSource;
import org.geotools.feature.FeatureCollection;
import org.geotools.filter.text.cql2.CQLException;
import org.geotools.filter.text.ecql.ECQL;
import org.geotools.referencing.CRS;
import org.opengis.feature.Feature;
import org.opengis.filter.Filter;
import org.opengis.referencing.FactoryException;
import org.vfny.geoserver.Request;
import org.vfny.geoserver.Response;

import com.vividsolutions.jts.geom.Geometry;

/**
 * @author Administrator
 *
 */
public class GetOutlayResponse implements Response {
	
	private Catalog catalog;
	private double outlay;
	
	/**
	 * 
	 */
	public GetOutlayResponse(Catalog catalog) {
		this.catalog = catalog;
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#execute(org.vfny.geoserver.Request)
	 */
	@Override
	public void execute(Request request) throws ServiceException {
		final GetOutlayRequest req = (GetOutlayRequest)request;
		FeatureTypeInfo fti = catalog.getFeatureTypeByName("my_cities");
		try {
			FeatureSource<?, ?> fs = fti.getFeatureSource(null, null);
			
			Filter filter = (Filter)ECQL.toFilter("NAME IN ('" + req.getCityFrom() + "','" + req.getCityTo() + "')");
			
			DefaultQuery q = new DefaultQuery("my_cities",filter);
			q.setCoordinateSystemReproject(CRS.decode("EPSG:54004"));//80
			
			FeatureCollection f = fs.getFeatures(q);
			Feature f1 = (Feature) f.toArray()[0];
			Feature f2 = (Feature) f.toArray()[1];
			Geometry geo1 = (Geometry) f1.getDefaultGeometryProperty().getValue();
			Geometry geo2 = (Geometry) f2.getDefaultGeometryProperty().getValue();
			double distance = geo1.distance(geo2) / 1000;
			
			outlay = distance * req.getWeight();
			
		} catch (IOException e) {
			throw new ServiceException(e);
		} catch (CQLException e) {
			throw new ServiceException(e);
		} catch (FactoryException e) {
			throw new ServiceException(e);
		} 
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#getContentType(org.geoserver.config.GeoServer)
	 */
	@Override
	public String getContentType(GeoServer gs) throws IllegalStateException {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#getContentEncoding()
	 */
	@Override
	public String getContentEncoding() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#getContentDisposition()
	 */
	@Override
	public String getContentDisposition() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#getResponseHeaders()
	 */
	@Override
	public HashMap getResponseHeaders() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#writeTo(java.io.OutputStream)
	 */
	@Override
	public void writeTo(OutputStream out) throws ServiceException, IOException {
		PrintStream printer = new PrintStream(out);
		printer.print(outlay);
	}

	/* (non-Javadoc)
	 * @see org.vfny.geoserver.Response#abort(org.geoserver.config.ServiceInfo)
	 */
	@Override
	public void abort(ServiceInfo gs) {
	}

}
